<?php

namespace App\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;

class LoopUserNotification extends Notification
{
    use Queueable;

    /**
     * Create a new notification instance.
     *
     * @return void
     */
    private $details= [];

    public function __construct($details= [])
    {
        $this->details= $details;
    }

    /**
     * Get the notification's delivery channels.
     *
     * @param  mixed  $notifiable
     * @return array
     */
    public function via($notifiable)
    {
        return [ 'database'];
        return ['mail', 'database'];
    }

    /**
     * Get the mail representation of the notification.
     *
     * @param  mixed  $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        return (new MailMessage)
                    ->line('The introduction to the notification.')
                    ->action('Notification Action', url('/'))
                    ->line('Thank you for using our application!');
    }

    /**
     * Get the array representation of the notification.
     *
     * @param  mixed  $notifiable
     * @return array
     */
    // public function toArray($notifiable)
    public function toDatabase ($notifiable)
    {
        if($notifiable->phone){
            // sendSMS($notifiable->phone, $this->details['message']);
        }

        return [
            'loop_group_id' => $this->details['loop_group_id'],
            'month' => (int)$this->details['month'] ?? 0,
            'type' => $this->details['type'] ?? '',
            'share' => $this->details['share'],
            'period' => $this->details['period'],
            'unpaidMonths' => $this->details['unpaidMonths'] ?? 0,
            'message' => $this->details['message'],
        ];
    }
}
